#ifndef MPICHANNEL_H
#define MPICHANNEL_H

#include <mpi.h>
#include "Channel.h"


class MPIChannel : public Channel
{

private:
	MPI_Comm m_comm;
	int m_dest;
	int m_tag;

public:

	MPIChannel(int dest, int tag, MPI_Comm comm);
	~MPIChannel();

	MPI_Comm getMPIComm();
	int getDest();
	int getTag();

	int read(void *buf, channel_datatype_t datatype, size_t count);

	int write(const void *buf, channel_datatype_t datatype, size_t count);

	int available();

};

#endif //MPIChannel
